xquery version "1.0";
declare variable $vo as xs:string external;
declare variable $upper := upper-case($vo);
declare variable $lower := lower-case($vo);
declare variable $description as xs:string external;
declare variable $retention_policy as xs:string external;
declare variable $requested_size as xs:string external;
declare variable $guaranteed_size as xs:string external;
declare variable $lifetime as xs:string external;
declare variable $storage_element_id as xs:string external;
declare variable $free_online_size as xs:decimal external;

declare variable $description_arg := if ($description="") then '' else concat(" -space_desc=", $description);
declare variable $retention_policy_arg := if ($retention_policy="") then '' else concat(" -retention_policy=", $retention_policy);
declare variable $requested_size_arg := if ($requested_size="") then '' else concat(" -desired_size=", $requested_size);
declare variable $guaranteed_size_arg := if ($guaranteed_size="") then '' else concat(" -guaranteed_size=", $guaranteed_size);
declare variable $lifetime_arg := if ($lifetime="") then '' else concat(" -lifetime=", $lifetime);
declare variable $free_online_size_arg as xs:decimal:= if ($free_online_size=0) then 0 else $free_online_size;

string-join(
for $voinfo in //GlueSE[@GlueSEUniqueID]/GlueSEControlProtocol[@GlueSEControlProtocolVersion='2.2.0'][@GlueSEControlProtocolEndpoint]/../GlueSA[@GlueSAFreeOnlineSize>=$free_online_size_arg]/GlueVOInfo[@GlueVOInfoAccessControlBaseRule=$vo or @GlueVOInfoAccessControlBaseRule=$upper or @GlueVOInfoAccessControlBaseRule=$lower]
  let $endpoint := $voinfo/../../GlueSEControlProtocol[@GlueSEControlProtocolVersion='2.2.0']/@GlueSEControlProtocolEndpoint
  let $seid := $voinfo/../../@GlueSEUniqueID
    return
      if ($storage_element_id="" or $storage_element_id=$seid) then
        concat("srm-reserve-space", $description_arg, $retention_policy_arg, $requested_size_arg, $guaranteed_size_arg, $lifetime_arg, " srm", substring($endpoint[1], 6), "&#xA;")
      else() 
,"")
