xquery version "1.0";
declare variable $vo as xs:string external;
declare variable $upper := upper-case($vo);
declare variable $lower := lower-case($vo);
declare variable $space_token as xs:string external;
declare variable $storage_element_id as xs:string external;
declare variable $free_online_size as xs:decimal external;

declare variable $space_token_arg := if ($space_token="") then '' else concat(" -space_token=", $space_token);
declare variable $free_online_size_arg as xs:decimal:= if ($free_online_size=0) then 0 else $free_online_size;
declare variable $cmd := concat("srmcp -srm_protocol_version=2", $space_token_arg, " file:////path/to/file");

string-join(
for $voinfo in //GlueSE[@GlueSEUniqueID]/GlueSEControlProtocol[@GlueSEControlProtocolVersion='2.2.0'][@GlueSEControlProtocolEndpoint]/../GlueSA[@GlueSAFreeOnlineSize>=$free_online_size_arg]/GlueVOInfo[@GlueVOInfoAccessControlBaseRule=$vo or @GlueVOInfoAccessControlBaseRule=$upper or @GlueVOInfoAccessControlBaseRule=$lower][@GlueVOInfoPath]
  let $rootpath := $voinfo/@GlueVOInfoPath
  let $endpoint := $voinfo/../../GlueSEControlProtocol[@GlueSEControlProtocolVersion='2.2.0']/@GlueSEControlProtocolEndpoint
  let $seid := $voinfo/../../@GlueSEUniqueID
    return
      if ($storage_element_id="" or $storage_element_id=$seid) then
        concat($cmd, " srm", substring($endpoint[1], 6), "?SFN=", $rootpath,  "/TESTFILE", "&#xA;")
      else() 
,"")
