package gov.fnal.xpathsearch.cache;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import org.apache.commons.cli.CommandLine;
import gov.fnal.xpathsearch.cache.filesystem.AccessFilesystem;
import gov.fnal.xpath2ldap.XMLAdapter;
import gov.fnal.xpath2ldap.Pair;

import java.util.Stack;
import java.util.LinkedHashMap;
import java.util.List;

public class AccessCache {
    static String cache_type;
    static String cachedir = System.getProperty("xpathsearch.cachedir", System.getProperty("xpathsearch.home", System.getProperty("user.home")) + "/cache");
    static String cachename = System.getProperty("xpathsearch.cachename", "bdii.xml");
    //static String cachename_dsml = System.getProperty("xpathsearch.cachenamedsml", "dsml_bdii.xml");
    //static String ancestormap = System.getProperty("xpathsearch.cachenameanc", "ancestors.xml");
    public static String FILESYSTEM="filesystem";
    public static String XMLDB="xmldb";

    public static enum Operation {
        CREATE, UPDATE;

        void go(Document document){

            if(XMLDB.equals(cache_type)) {
                try {
                    //String response_str = XMLAdapter.serialize(response);
                    //AccessXMLDB.update(response_str, "bdii", "is.grid.iu.edu");
                } catch (Exception e) {
                    System.err.println("Could not add response to xmldb database.");
                    e.printStackTrace();
                } finally {
                    try {
                        //XMLDB.XMLDBFactory.getInstance().close();
                    } catch (Exception e) {
                        System.err.println("Could not close XMLDBFactory.");
                        e.printStackTrace();
                    }
                }
            } else if(FILESYSTEM.equals(cache_type)) {
                try {
                    switch(this) {
                        case CREATE:
                            AccessFilesystem.create(document, cachename, cachedir); return;
                        case UPDATE:
                            AccessFilesystem.update(document, cachename, cachedir); return;
                    }
                    throw new AssertionError("Unknown op: " + this);
                }   catch (Exception e) {
                    System.err.println("Could not add response to filesystem database.");
                    e.printStackTrace();
                }
            } else {
                try {
                    XMLAdapter.serialize(document, System.out);
                } catch (Exception e) {
                    System.err.println("Could not serialize result " + e);
                }
            }
        }

    }
}
