xquery version "1.0";
(: Returns a Compute Element mount point for a Storage Element which authorizes the specified VO, followed by the associated job manager. :)

import module namespace osg="http://opensciencegrid.org" at "functions.xq";

declare variable $vo as xs:string external;
declare variable $fqan := osg:clean_fqan($vo);
declare variable $compute_element_id as xs:string external;
declare variable $storage_element_id as xs:string external;
declare variable $site_name as xs:string external;

string-join(
  for $cese in //GlueCESEBind[@dn][@GlueCESEBindMountInfo]
    let $seroot0 := substring-after($cese/@GlueCESEBindMountInfo, ",")
    let $seroot  := if ($seroot0='/') then '' else $seroot0
    let $ceroot0 := substring-before($cese/@GlueCESEBindMountInfo, ",")
    let $ceroot  := if ($ceroot0='/') then '' else $ceroot0
    let $befceid := substring-before($cese/@dn, "GlueCESEBindGroupCEUniqueID")
    let $aftseid := substring-after($befceid, "GlueCESEBindSEUniqueID=")
    let $seid_cese := substring-before($aftseid, ",")
    let $befsitename := substring-before($cese/@dn, "Mds-Vo-name=")
    let $aftceid := substring-after($befsitename, "GlueCESEBindGroupCEUniqueID=")
    let $ceid_cese := substring-before($aftceid, ",")
    let $aftsitename := replace($cese/@dn, concat($befsitename, "Mds-Vo-name="), "")
    let $site_name_cese := substring-before($aftsitename, ",")
    for $acbr in (//GlueSE[@GlueSEUniqueID]/GlueSEAccessProtocol[@GlueSEAccessProtocolType='file']/../GlueSA/(@GlueSAAccessControlBaseRule | GlueVOInfo[@GlueVOInfoPath]/@GlueVOInfoAccessControlBaseRule))
      let $child_acbrs := $acbr/../GlueVOInfo[@GlueVOInfoPath]/@GlueVOInfoAccessControlBaseRule
      let $rootpath := $acbr/../(@GlueSAPath|@GlueVOInfoPath)
      let $seid_se := $acbr/(.|..)/../../@GlueSEUniqueID
      return
        if ($site_name="" or $site_name=$site_name_cese) then
          if ($storage_element_id="" or $storage_element_id=$seid_cese) then
            if ($compute_element_id="" or $compute_element_id=$ceid_cese) then
              if ($seid_cese=$seid_se) then
                if (string-length($seroot)>0 or $seroot0='/') then
	          if (string-length($ceroot)>0 or $ceroot0='/') then
		    if(osg:acbr_match($acbr, $fqan)) then
		      if($acbr/..[@GlueVOInfoPath] or ($acbr/..[@GlueSAPath] and fn:not(osg:acbr_nodes_match($child_acbrs, $fqan)))) then
                        concat("&#x22;", $ceid_cese, "&#x22;", "&#x20;", "&#x22;", $ceroot, substring-after($rootpath, $seroot), "&#x22;", "&#xA;")
		      else()
		    else()
	          else()
	        else()
              else ()
	    else ()
	  else ()
	else ()
,"")
