xquery version "1.0";
(: Finds operating system versions for clusters and sites. :)

import module namespace osg="http://opensciencegrid.org" at "functions.xq";

declare variable $vo as xs:string external;
declare variable $fqan := osg:clean_fqan($vo);
declare variable $match as xs:string external;

string-join(
  for $os in //GlueCluster[@GlueClusterUniqueID][@GlueForeignKey]/GlueSubCluster[@GlueChunkKey][@GlueHostOperatingSystemVersion][@GlueHostOperatingSystemRelease]/@GlueHostOperatingSystemName
    let $osv := concat($os, "&#x20;", $os/../@GlueHostOperatingSystemVersion, "&#x20;", $os/../@GlueHostOperatingSystemRelease)
    let $osver := osg:get_attr_csv_match($osv, $match)     
    let $clid_subc := osg:get_attr_1st_match($os/../@GlueChunkKey, "GlueClusterUniqueID=")     
    let $stid_clus := osg:get_attr_1st_match($os/../../@GlueForeignKey, "GlueSiteUniqueID=")
    for $acbr in //GlueCE[@GlueCEUniqueID][@GlueForeignKey]/(. | GlueVOView)/@GlueCEAccessControlBaseRule
      let $cefk := $acbr/(.|..)/../@GlueForeignKey
      let $clid_ce := osg:get_attr_1st_match($cefk, "GlueClusterUniqueID=") 
      return
        if ($clid_ce=$clid_subc) then
	  if (string-length($osver)!=0) then
	    if(osg:acbr_match($acbr, $fqan)) then
              concat("&#x22;", $stid_clus, "&#x22;", "&#x20;", "&#x22;", $cefk/../@GlueCEUniqueID, "&#x22;", "&#x20;", "&#x22;", $osver, "&#x22;", "&#xA;")
	    else()
	  else()
	else()   
,"")
