xquery version "1.0";
(: Finds runtime software versions for clusters and sites. :)

import module namespace osg="http://opensciencegrid.org" at "functions.xq";

declare variable $vo as xs:string external;
declare variable $fqan := osg:clean_fqan($vo);
declare variable $match as xs:string external;

string-join(
  for $rtenv in //GlueCluster[@GlueClusterUniqueID][@GlueForeignKey]/GlueSubCluster[@GlueChunkKey]/@GlueHostApplicationSoftwareRunTimeEnvironment
    let $rte := osg:get_attr_csv_match($rtenv, $match)     
    let $clid_subc := osg:get_attr_1st_match($rtenv/../@GlueChunkKey, "GlueClusterUniqueID=")     
    let $stid_clus := osg:get_attr_1st_match($rtenv/../../@GlueForeignKey, "GlueSiteUniqueID=")
    for $acbr in //GlueCE[@GlueCEUniqueID][@GlueForeignKey]/(. | GlueVOView)/@GlueCEAccessControlBaseRule
      let $cefk := $acbr/(.|..)/../@GlueForeignKey
      let $clid_ce := osg:get_attr_1st_match($cefk, "GlueClusterUniqueID=") 
      return
        if ($clid_ce=$clid_subc) then
	  if (string-length($rte)!=0) then
	    if(osg:acbr_match($acbr, $fqan)) then
              concat("&#x22;", $stid_clus, "&#x22;", "&#x20;", "&#x22;", $cefk/../@GlueCEUniqueID, "&#x22;", "&#x20;", "&#x22;", $rte, "&#x22;", "&#xA;")
	    else()
	  else()
	else()   
,"")
