xquery version "1.0";
(: Returns a list of sites that authorize Storage Element access for the specified VO. Or, find the site name for the storage element with the specified storage element id. :)

import module namespace osg="http://opensciencegrid.org" at "functions.xq";

declare variable $vo as xs:string external;
declare variable $fqan := osg:clean_fqan($vo);
declare variable $storage_element_id as xs:string external;
declare variable $show_storage_element_id as xs:string external;

declare variable $header_str := concat("&#x22;", "STORAGE ELEMENT ID", "&#x22;", "&#x20;", "&#x22;", "SITE NAME", "&#x22;", "&#xA;");
declare variable $header := if ($show_storage_element_id='') then $header_str else "";

concat($header,
string-join(
for $acbr in (//GlueSE[@GlueSEUniqueID]/GlueSA/(@GlueSAAccessControlBaseRule | GlueVOInfo[@GlueVOInfoPath]/@GlueVOInfoAccessControlBaseRule))
    let $child_acbrs := $acbr/../GlueVOInfo[@GlueVOInfoPath]/@GlueVOInfoAccessControlBaseRule
    let $sedn := $acbr/(.|..)/../..[@GlueSEUniqueID]/@dn
    let $bef := substring-before($sedn, "Mds-Vo-name=")
    let $aft := replace($sedn, concat($bef, "Mds-Vo-name="), "")
    let $site_name := substring-before($aft, ",")
    let $seid := $acbr/(.|..)/../../@GlueSEUniqueID
    return
    if ($storage_element_id="" or $storage_element_id=$seid) then
      if ($site_name!="") then
        if(osg:acbr_match($acbr, $fqan)) then
          if($acbr/..[@GlueVOInfoPath] or ($acbr/..[@GlueSAPath] and fn:not(osg:acbr_nodes_match($child_acbrs, $fqan)))) then
	    if($show_storage_element_id='') then
	      concat("&#x22;", $seid, "&#x22;", "&#x20;", "&#x22;", $site_name, "&#x22;", "&#xA;")
	    else
              concat("&#x22;", $site_name, "&#x22;", "&#xA;")
	  else()
        else()
      else()
    else()
,""))
