xquery version "1.0";
(: Returns the site name for a storage element with the given id. See the command get_storage_element_id for finding Storage Element IDs by VO name. :)

declare variable $storage_element_id as xs:string external;

string-join(
for $se in //GlueSE[@GlueSEUniqueID=$storage_element_id]
    let $bef := substring-before($se/@dn, "Mds-Vo-name=")
    let $aft := replace($se/@dn, concat($bef, "Mds-Vo-name="), "")
    let $site_name := substring-before($aft, ",")
    return concat("&#x22;", $site_name, "&#x22;", "&#xA;"), 
"")
