xquery version "1.0";
(: Returns a list of example srm_copy commands for Storage Elements on which the specified VO is authorized. :)

import module namespace osg="http://opensciencegrid.org" at "functions.xq";

declare variable $vo as xs:string external;
declare variable $fqan := osg:clean_fqan($vo);
declare variable $space_token as xs:string external;
declare variable $storage_element_id as xs:string external;
declare variable $free_online_size as xs:decimal external;
declare variable $show_storage_element_id as xs:string external;

declare variable $space_token_arg := if ($space_token="") then '' else concat(" -spacetoken ", $space_token);
declare variable $free_online_size_arg as xs:decimal:= if ($free_online_size=0) then 0 else $free_online_size;
declare variable $header_str := concat("&#x22;", "STORAGE ELEMENT ID", "&#x22;", "&#x20;", "&#x22;", "SRM_COPY COMMAND", "&#x22;", "&#xA;");
declare variable $header := if ($show_storage_element_id='') then $header_str else "";

concat($header,
string-join(
for $acbr in (//GlueSE[@GlueSEUniqueID]/GlueSEControlProtocol[@GlueSEControlProtocolVersion='2.2.0'][@GlueSEControlProtocolEndpoint]/../GlueSA[@GlueSAFreeOnlineSize>=$free_online_size_arg][@GlueSAPath]/(@GlueSAAccessControlBaseRule | GlueVOInfo[@GlueVOInfoPath]/@GlueVOInfoAccessControlBaseRule))
  let $child_acbrs := $acbr/../GlueVOInfo[@GlueVOInfoPath]/@GlueVOInfoAccessControlBaseRule
  let $rootpath := $acbr/../(@GlueSAPath|@GlueVOInfoPath)
  let $endpoint := $acbr/(.|..)/../..[@GlueSEUniqueID]/GlueSEControlProtocol[@GlueSEControlProtocolVersion='2.2.0']/@GlueSEControlProtocolEndpoint
  let $seid := $acbr/(.|..)/../../@GlueSEUniqueID
    return
      if ($storage_element_id="" or $storage_element_id=$seid) then
        if(osg:acbr_match($acbr, $fqan)) then
	  if($acbr/..[@GlueVOInfoPath] or ($acbr/..[@GlueSAPath] and fn:not(osg:acbr_nodes_match($child_acbrs, $fqan)))) then
	    if($show_storage_element_id='') then	  	        
	      concat("&#x22;", $seid, "&#x22;", "&#x20;", "&#x22;", "srm-copy file:////path/to/file", " srm", substring($endpoint[1], 6), "?SFN=", $rootpath,  "/TESTFILE", $space_token_arg, "&#x22;", "&#xA;")
	    else
              concat("&#x22;", "srm-copy file:////path/to/file", " srm", substring($endpoint[1], 6), "?SFN=", $rootpath,  "/TESTFILE", $space_token_arg, "&#x22;", "&#xA;")
	  else()
	else()
      else() 
,""))
