xquery version "1.0";
(: Returns a list of IDs for Storage Elements on which the specified VO is authorized. :)

import module namespace osg="http://opensciencegrid.org" at "functions.xq";

declare variable $vo as xs:string external;
declare variable $fqan := osg:clean_fqan($vo);
declare variable $free_online_size as xs:decimal external;
declare variable $show_site_name as xs:string external;

declare variable $free_online_size_arg as xs:decimal:= if ($free_online_size=0) then 0 else $free_online_size;
declare variable $header_str := concat("&#x22;", "SITE NAME", "&#x22;", "&#x20;", "&#x22;", "STORAGE ELEMENT ID", "&#x22;", "&#xA;");
declare variable $header := if ($show_site_name='') then $header_str else "";

concat($header,
string-join(
for $acbr in (//GlueSE[@GlueSEUniqueID]/GlueSEControlProtocol[@GlueSEControlProtocolType='SRM']/../GlueSA[@GlueSAFreeOnlineSize>=$free_online_size_arg]/(@GlueSAAccessControlBaseRule | GlueVOInfo/@GlueVOInfoAccessControlBaseRule))
    let $child_acbrs := $acbr/../GlueVOInfo[@GlueVOInfoPath]/@GlueVOInfoAccessControlBaseRule
    let $sedn := $acbr/(.|..)/../..[@GlueSEUniqueID]/@dn
    let $bef := substring-before($sedn, "Mds-Vo-name=")
    let $aft := replace($sedn, concat($bef, "Mds-Vo-name="), "")
    let $site_name := substring-before($aft, ",")
    let $seid := $acbr/(.|..)/../../@GlueSEUniqueID
    return
      if(osg:acbr_match($acbr, $fqan)) then
        if($acbr/..[@GlueVOInfoPath] or ($acbr/..[@GlueSAPath] and fn:not(osg:acbr_nodes_match($child_acbrs, $fqan)))) then
          if($show_site_name='') then	  	        
	    concat("&#x22;", $site_name, "&#x22;", "&#x20;", "&#x22;", $seid, "&#x22;", "&#xA;")
	  else	    
            concat("&#x22;", $seid, "&#x22;", "&#xA;")
	else()
      else()     
,""))
