xquery version "1.0";
(: Finds storage areas and returns space and path info. Optionally restrict by fqan and/or Storage Element ID. :)

import module namespace osg="http://opensciencegrid.org" at "functions.xq";
import module namespace functx="http://www.functx.com" at "./functx-1.0-nodoc-2007-01.xquery";

declare variable $vo as xs:string external;
declare variable $match_any as xs:string external;
declare variable $fqanlist := osg:clean_fqan($vo);
declare variable $storage_element_id as xs:string external;
declare variable $free_online_size as xs:decimal external;
declare variable $free_online_size_arg as xs:decimal:= if ($free_online_size=0) then 0 else $free_online_size;
declare variable $show_site_name as xs:string external;
declare variable $show_storage_element_id as xs:string external;
declare variable $hide_vo as xs:string external;

declare variable $header_str1 := concat("&#x22;", "SITE NAME", "&#x22;&#x20;&#x22;", "STORAGE AREA NAME", "&#x22;&#x20;&#x22;", "TOTAL", "&#x22;&#x20;&#x22;", "FREE", "&#x22;&#x20;&#x22;", "VOs", "&#x22;&#xA;");
declare variable $header_str2 := concat("&#x22;", "STORAGE ELEMENT ID", "&#x22;&#x20;&#x22;", "STORAGE AREA NAME", "&#x22;&#x20;&#x22;", "TOTAL", "&#x22;&#x20;&#x22;", "FREE", "&#x22;&#x20;&#x22;", "VOs", "&#x22;&#xA;");
declare variable $header_str3 := concat("&#x22;", "SITE NAME", "&#x22;&#x20;&#x22;", "STORAGE AREA NAME", "&#x22;&#x20;&#x22;", "TOTAL", "&#x22;&#x20;&#x22;", "FREE", "&#x22;&#xA;");
declare variable $header_str4 := concat("&#x22;", "STORAGE ELEMENT ID", "&#x22;&#x20;&#x22;", "STORAGE AREA NAME", "&#x22;&#x20;&#x22;", "TOTAL", "&#x22;&#x20;&#x22;", "FREE", "&#x22;&#xA;");
declare variable $header := if ($show_site_name='') then if ($hide_vo='') then $header_str3 else $header_str1 else if ($hide_vo='') then $header_str4 else $header_str2;

(: Returns a string containing a csv list of fqans which match any node :)
declare function osg:print_storage_area($seid as xs:string, $site_name as xs:string, $saname as xs:string, $total as xs:string, $free as xs:string, $matchlist as xs:string, $fqanlist as xs:string) as xs:string {
    if($header=$header_str1) then	  	        
	  concat("&#x22;", $site_name, "&#x22;&#x20;&#x22;", $saname, "&#x22;&#x20;", $total, "&#x20;", $free, "&#x20;&#x22;", $matchlist, "&#x22;&#xA;")
	else if($header=$header_str2) then	
	  concat("&#x22;", $seid, "&#x22;&#x20;&#x22;", $saname, "&#x22;&#x20;", $total, "&#x20;", $free, "&#x20;&#x22;", $matchlist, "&#x22;&#xA;")
	else if($header=$header_str3) then	
	  concat("&#x22;", $site_name, "&#x22;&#x20;&#x22;", $saname, "&#x22;&#x20;", $total, "&#x20;", $free, "&#xA;")
	else if($header=$header_str4) then	
	  concat("&#x22;", $seid, "&#x22;&#x20;&#x22;", $saname, "&#x22;&#x20;", $total, "&#x20;", $free, "&#xA;")
	else	
	  concat($free, "&#xA;")
};

concat($header,
string-join(
for $sa in (//GlueSE[@GlueSEUniqueID]/GlueSEControlProtocol[@GlueSEControlProtocolVersion='2.2.0'][@GlueSEControlProtocolEndpoint]/../GlueSA[@GlueSAFreeOnlineSize>=$free_online_size_arg][@GlueSATotalOnlineSize>=$free_online_size_arg][@GlueSAPath][@GlueSAName])
  let $endpoint := $sa/../GlueSEControlProtocol[@GlueSEControlProtocolVersion='2.2.0']/@GlueSEControlProtocolEndpoint
  let $sedn := $sa/..[@GlueSEUniqueID]/@dn
  let $bef := substring-before($sedn, "Mds-Vo-name=")
  let $aft := replace($sedn, concat($bef, "Mds-Vo-name="), "")
  let $site_name := substring-before($aft, ",")
  let $seid := $sa/../@GlueSEUniqueID  
  let $free := $sa/@GlueSAFreeOnlineSize
  let $total := $sa/@GlueSATotalOnlineSize
  let $saname := $sa/@GlueSAName
  let $sa_acbr := $sa/@GlueSAAccessControlBaseRule  
  let $sa_matchlist := osg:acbr_nodes_matchlist($sa_acbr, $fqanlist)
  let $info_acbrs := $sa/GlueVOInfo[@GlueVOInfoPath]/@GlueVOInfoAccessControlBaseRule
  let $info_matchlist := osg:acbr_nodes_matchlist($info_acbrs, $fqanlist)
  let $both_matchlist := osg:union_csv_ordered($info_matchlist, $sa_matchlist)
  return    
    if ($storage_element_id="" or $storage_element_id=$seid) then
      if($fqanlist!="") then
        if(string-length($both_matchlist)>0) then
          if ($match_any="" or $both_matchlist=osg:to_csv(functx:sort(osg:insert_csv((), $fqanlist)))) then
	    osg:print_storage_area($seid, $site_name, $saname, $total, $free, $both_matchlist, $fqanlist)
	  else()
        else()
      else
        if (string-length($both_matchlist)>0) then 
          osg:print_storage_area($seid, $site_name, $saname, $total, $free, $both_matchlist, $fqanlist)
	else()  
    else() 
,""))
