xquery version "1.0";
(: Finds the Storage Elements for which the vo or role is authorized and constructs an example SURL with the appropriate root path. :)

import module namespace osg="http://opensciencegrid.org" at "functions.xq";

declare variable $vo as xs:string external;
declare variable $fqan := osg:clean_fqan($vo);
declare variable $storage_element_id as xs:string external;
declare variable $free_online_size as xs:decimal external;
declare variable $free_online_size_arg as xs:decimal:= if ($free_online_size=0) then 0 else $free_online_size;
declare variable $show_site_name as xs:string external;
declare variable $show_storage_element_id as xs:string external;

declare variable $header_str1 := concat("&#x22;", "SITE NAME", "&#x22;", "&#x20;", "&#x22;", "SURL", "&#x22;", "&#xA;");
declare variable $header_str2 := concat("&#x22;", "STORAGE ELEMENT ID", "&#x22;", "&#x20;", "&#x22;", "SURL", "&#x22;", "&#xA;");
declare variable $header_str3 := concat("&#x22;", "SITE NAME", "&#x22;", "&#x20;", "&#x22;", "STORAGE ELEMENT ID", "&#x22;", "&#x20;", "&#x22;", "SURL", "&#x22;", "&#xA;");
declare variable $header := if ($show_site_name='') then if ($show_storage_element_id='') then $header_str3 else $header_str1 else if ($show_storage_element_id='') then $header_str2 else "";

concat($header,
string-join(
for $acbr in (//GlueSE[@GlueSEUniqueID]/GlueSEControlProtocol[@GlueSEControlProtocolVersion='2.2.0'][@GlueSEControlProtocolEndpoint]/../GlueSA[@GlueSAFreeOnlineSize>=$free_online_size_arg][@GlueSAPath]/(@GlueSAAccessControlBaseRule | GlueVOInfo[@GlueVOInfoPath]/@GlueVOInfoAccessControlBaseRule))
  let $child_acbrs := $acbr/../GlueVOInfo[@GlueVOInfoPath]/@GlueVOInfoAccessControlBaseRule
  let $rootpath := $acbr/../(@GlueSAPath|@GlueVOInfoPath)
  let $endpoint := $acbr/(.|..)/../../GlueSEControlProtocol[@GlueSEControlProtocolVersion='2.2.0']/@GlueSEControlProtocolEndpoint
  let $sedn := $acbr/(.|..)/../..[@GlueSEUniqueID]/@dn
  let $bef := substring-before($sedn, "Mds-Vo-name=")
  let $aft := replace($sedn, concat($bef, "Mds-Vo-name="), "")
  let $site_name := substring-before($aft, ",")
  let $seid := $acbr/(.|..)/../../@GlueSEUniqueID  
  return    
    if ($storage_element_id="" or $storage_element_id=$seid) then
      if(osg:acbr_match($acbr, $fqan)) then
        if($acbr/..[@GlueVOInfoPath] or ($acbr/..[@GlueSAPath] and fn:not(osg:acbr_nodes_match($child_acbrs, $fqan)))) then
	  if($header=$header_str1) then	  	        
	    concat("&#x22;", $site_name, "&#x22;", "&#x20;", "&#x22;", "srm", substring($endpoint[1], 6), "?SFN=", $rootpath,  "/TESTFILE", "&#x22;", "&#xA;")
	  else if($header=$header_str2) then	
	    concat("&#x22;", $seid, "&#x22;", "&#x20;", "&#x22;", "srm", substring($endpoint[1], 6), "?SFN=", $rootpath,  "/TESTFILE", "&#x22;", "&#xA;")
	  else if($header=$header_str3) then
	    concat("&#x22;", $site_name, "&#x22;", "&#x20;", "&#x22;", $seid, "&#x22;", "&#x20;", "&#x22;", "srm", substring($endpoint[1], 6), "?SFN=", $rootpath,  "/TESTFILE", "&#x22;", "&#xA;")
	  else	
	    concat("&#x22;", "srm", substring($endpoint[1], 6), "?SFN=", $rootpath,  "/TESTFILE", "&#x22;", "&#xA;")
	else()
      else() 
    else() 
,""))

