package gov.fnal.xpathsearch.cache;

import java.util.List;
import java.util.Stack;
import java.util.LinkedHashMap;
import java.io.*;

import org.w3c.dom.*;

import org.apache.commons.cli.CommandLine;
import gov.fnal.xpath2ldap.XMLAdapter;
import gov.fnal.xpath2ldap.LPathSearch;
import gov.fnal.xpath2ldap.DSMLTransform;
import gov.fnal.xpath2ldap.Pair;

/**
 * User: tdh
 * Date: Dec 15, 2008
 * Time: 10:10:07 AM
 */

public class XPathCacheLoadEvaluator {
        XMLAdapter xmler;
        LPathSearch searcher;
        DSMLTransform xformer;
        boolean write_source_xml=true;

    public XPathCacheLoadEvaluator(CommandLine cmdline) {
        xmler = new XMLAdapter(cmdline);
        searcher = new LPathSearch(xmler);
        xformer = new DSMLTransform(xmler);
    }

    public XPathCacheLoadEvaluator(String hostname, int port) {
        xmler = new XMLAdapter(hostname, port);
        searcher = new LPathSearch(xmler);
        xformer = new DSMLTransform(xmler);
    }

    public Document search(List<String> lFullPaths) {
        Pair<Document, LinkedHashMap<String, Stack<String>>> fromLPathSearch;
        fromLPathSearch = searcher.search(lFullPaths);
        Document fromldap = transform(fromLPathSearch);
        return fromldap;
    }

    public Document transform(Pair<Document, LinkedHashMap<String, Stack<String>>> fromLPathSearch) {
        Document fromldap = xformer.xformDSMLToStructuredXML(fromLPathSearch);
        return fromldap;
    }

    public Pair<Document, LinkedHashMap<String, Stack<String>>> search(List<String> lFullPaths, Document dsml_format) {
        Pair<Document, LinkedHashMap<String, Stack<String>>> fromLPathSearch;
        fromLPathSearch = searcher.search(lFullPaths, dsml_format);
        return fromLPathSearch;
        //String response=null;
        //try {
        //    ByteArrayOutputStream baos = new ByteArrayOutputStream();
        //    XMLAdapter.serialize(fromldap, baos);
        //    response = baos.toString();
        //} catch (Exception e) {
        //    System.err.println("Could not serialize result " + e);
        //}
        //return response;
    }

}